unit phylParente;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, Grids, MyNewgrid,listarray2,
  ExtCtrls,grapheboite,typedef,StructureDonnees,Donnees,GR32,GR32_Layers,GR32_Image,
  Menus, Buttons, ImgList,ColorStringGrid,ArbreDate;

type
  TFormParente = class(TForm)

    Panel1: TPanel;
    Splitter1: TSplitter; //botes
    PanelArbre: TPanel;
    Splitter2: TSplitter;
    PanelGrille: TPanel;
    TabGrid2: TTabGrid;
    TabGrid1: TTabGrid;
    PanelCom: TPanel;
    MenuChoixDeplace: TPopupMenu;
    ActiverLeDeplacement: TMenuItem;
    ActiverSelectionCaract: TMenuItem;
    PanLegCoul: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    PanelBoutons: TPanel;
    Bdepla: TSpeedButton;
    Bboites: TSpeedButton;
    BDocs: TSpeedButton;
    BMArbre: TSpeedButton;
    BRaz: TSpeedButton;
    BVerifier: TButton;
    BRej: TSpeedButton;
    ActiverAffichageDocs: TMenuItem;
    PanActiv: TPanel;
    PanAfA: TPanel;
    PanBRej: TPanel;
    TextMArbre: TLabel;
    TextRej: TLabel;
    PanBRaz: TPanel;
    TextRaz: TLabel;
    PanBDepl: TPanel;
    TextDepla: TLabel;
    PanBBoites: TPanel;
    TextBoites: TLabel;
    PanBDocs: TPanel;
    TextDocs: TLabel;
    PanRejouer: TPanel;
    BDeb: TSpeedButton;
    BAR1: TSpeedButton;
    BAV1: TSpeedButton;
    BFin: TSpeedButton;
    BDater: TButton;
    PanelActivArbre: TPanel;
    ScrollBoxArbre: TScrollBox;
    MenuchoixArbre: TPopupMenu;
    AfficherBoitesArbre: TMenuItem;
    ScrollBoxBoites: TScrollBox;
    AvertisArbre: TPanel;
    Label3: TLabel;
    CopieBBoite: TSpeedButton;
    AfficherGroupes: TMenuItem;
    PanelInfo: TPanel;
    BChoix: TPanel;
    N1: TMenuItem;
    ArbreModifiable: TMenuItem;
    AfficherTaxons: TMenuItem;
    procedure TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
//    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure Splitter2CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure RAZClick(Sender: TObject);
    procedure ActiverClick(Sender: TObject);
    procedure BDebClick(Sender: TObject);
    procedure BAV1Click(Sender: TObject);
    procedure BAR1Click(Sender: TObject);
    procedure BFinClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BRej_Click(Sender: TObject);
    procedure BVerifier_ancClick(Sender: TObject);
    procedure BdeplaClick(Sender: TObject);
    procedure BMArbre_Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure PanelComClick(Sender: TObject);
    procedure TabGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BDaterClick(Sender: TObject);
    procedure ScrollBoxArbreResize(Sender: TObject);
    procedure AfficherBoitesArbreClick(Sender: TObject);
    procedure AfficherGroupesClick(Sender: TObject);
    procedure BChoixClick(Sender: TObject);
    procedure ArbreModifiableClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AfficherTaxonsClick(Sender: TObject);
    procedure PanelArbreResize(Sender: TObject);
      {procedure afficherNode (node :TNodeBoite)    ;
      procedure afficherNodeG (nodeG :TNodeBoiteG)  ;  }
  private
    { Dclarations prives}
    InactiveMouseUp:Boolean;
    CoulColCarct:Array of TColor;
    MaxiTaxEtatDeriv:integer; // nombre maxi de taxons tant  l'tat driv pour un caractre
    CarMaxTaxED:string;
    NbTaxEtatDeriv:Array of integer; // nombre de taxons tant  l'tat driv pour le caractre i
                                     //l'indice correspond  la numrotation des caracteresD
    EtatsDerives:TStringList;

    //procedure CliqueSurRacine;
    procedure VerifierArbre;
    procedure AjusteActive;
    procedure RAZGraphBoites;
    Procedure Affichetiq(etat:Boolean);
    Procedure ChangeSupport(Condense:Boolean);
    procedure AncetreClique(sender:Tobject);
    procedure UnGroupeEstANommer(Sender:Tobject);
    procedure UnGroupeEstNomme(Sender:Tobject);
    procedure AjusterInfo(sender:Tobject);
    procedure ArbreCladeMouseUp(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ArbreCladeMouseDown(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    function AjouterBoite(LeCaractere:String;Couleur:TColor32):Boolean;
    procedure GrapheBoiteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer;Layer:TCustomLayer);
    procedure GrapheBoiteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer;Layer:TCustomLayer);
  public  { Dclarations publiques}
     //TabCod : TStrListArray;
     ArbreClade:TArbreDate;
     GrapheBoite:TGrapheBoite;
     Mouchard:TStringList; //Ajout JFM 19/05/08
     MouchardSimplifie:TStringList; //Ajout JFM 19/05/08
     PosMouchard:integer;
     RacineSansCarDerive:boolean;
     DeplacementPossible:boolean;
     AfDExcl,AfD,AfA:TAffichCoul;
     AfOK,AfImpos,AfErr,AfMoins:TAffichCoul;
     ListeType:TStringList;
     CaracImpossibles:TStringList;
     ValeurRef:Array of integer; // nombre de taxons tant  l'tat driv pour le caractre
                                 // index comme ListeType
     NommerBoite:Boolean;
     BoiteANommer:TBoiteLayer;
     GroupeANommer:TStringList;
     NumeroGroupe:integer;
     LeDernierAncetreClique:TBranche;
     LaBoiteduDernierAncetreClique:TBoiteLayer;
     ListeTaxonsActifs:TStringList;
     //CouleursBoites:Array of Array of TColor32;

     //ArbreDisponible:boolean;
     procedure ChargeTabGrid;
     procedure  rechercherEtatDerives( caractere :String);
     function  rechercherEtatPrimitif( caractere :String): string;
     procedure afficheArbre; // affichage de l'arbre ajout JFM 12/04/08
     procedure RejoueMouchard;
     procedure TabGrid1ClicCaractere(col:integer);
     procedure VerifieTypeRacine;
     function ArbreAffichable:boolean;
     procedure Corriger;
     procedure CalculeListeRef;
     procedure ColoreMatrice;
     procedure ReclasserTableau(TableauRef:TStrListArray);
     procedure RetracerArbre(BranchesCreuses:Boolean);
     //procedure CalculeCouleursBoites;
     //procedure SimplifieMouchard;
  end;

var
  FormParente: TFormParente;

implementation

uses PhylChoi, PhylMain,math,fenarbre,ChxCoul,AfDocs,FenCaractAncetre,FicEssai,PhylDater,
      NmGroup; //, FenEtatcarac,node

{$R *.DFM}

procedure TFormParente.ColoreMatrice;
Var
  i,j,n:integer;
  AfficheDerive:TAffichCell;
  AfficheRaz:TAffichCell;
  LeCarD:TCaractD;
  etat:string;
  NomCaractere:string;
begin
  if  ColorerDerive then  // Pour colorer le fond du texte correspondant  une cellule dont l'tat est volu
    begin
      AfficheDerive.Active:=True;
      AfficheDerive.CouleurFond:=clYellow;
      AfficheDerive.CouleurTexte:=clBlack;
      AfficheDerive.styleFond:=bsSolid;
      AfficheDerive.CouleurContour:=ClBlack;
      AfficheRaz:=AfficheDerive;
      AfficheRaz.Active:=False;
      AfficheRaz.CouleurFond:=clWhite;

      For i:=1 to TabGrid1.ColCount-1 do
        begin
          LeCarD:=LaSousCollection.LeCarD(TabGrid1.Cells[i,0]);
          if LeCarD<>Nil then
            begin
              For j:=1 to TabGrid1.RowCount-1 do
                begin
                  if (TabGrid1.Cells[i,j]<>'?') and (LeCarD.ListeEtats.IndexOf(TabGrid1.Cells[i,j])>0) then
                  //TabGrid1.Cells[i,j]=rechercherEtatDerive(carac) then
                    begin
                      //UnAffichage.CouleurContour:=CoulColCarct[i-1];
                      TabGrid1.AffichCell[i,j]:=AfficheDerive;
                      //UnAffichage:=AfficheDerive;
                    end
                  else TabGrid1.AffichCell[i,j]:=AfficheRaz;
                  {else if TabGrid1.Cells[i,j]=rechercherEtatPrimitif(carac) then
                    TabGrid1.AffichCell[i,j]:=AffichePrimitif;}
                end;
            end;
        end;
      if FicheCarAncetre.Visible then
        begin
          For i:=1 to FicheCarAncetre.ColorStringGrid.RowCount-1 do
            begin
              if AfficCoulIdentiques(FicheCarAncetre.ColorStringGrid.AffichCell[1,i],ConvertitAffCelAffCoul(ModDeriveExcl)) then
                begin
                  NomCaractere:=FicheCarAncetre.ColorStringGrid.Cells[0,i];
                  n:=TabGrid1.Rows[0].IndexOf(NomCaractere);
                  if n>0 then
                    begin
                      etat:=FicheCarAncetre.ColorStringGrid.Cells[1,i];
                      for j:=1 to TabGrid1.RowCount-1 do
                        begin
                          if TabGrid1.Cells[n,j]=etat then TabGrid1.AffichCell[n,j]:=ModDeriveExcl;
                        end;
                    end;
                end;
            end;
        end;
      TabGrid1.Refresh;
    end;
end;

procedure TFormParente.ReclasserTableau(TableauRef:TStrListArray);
Var
  i,n:integer;
  ListeSelection: TStringList;
begin
  ListeSelection:=TStringList.Create;
  For i:=1 to TabGrid1.ColCount-1 do
    if TabGrid1.SelectCol[i] then ListeSelection.Add(TabGrid1.Cells[i,0]);
  TabGrid1.SelectAllCol(False);
  TabGrid1.RowCount:=TableauRef.RowCount;
  TabGrid1.ColCount:=TableauRef.GetMaxColCount;
  TabGrid1.copyFromAlistArray(0,0,TableauRef);
  TabGrid1.AdjustColWidths;

  For i:=0 to ListeSelection.Count-1 do
    begin
      n:=TabGrid1.Rows[0].IndexOf(ListeSelection[i]);
      if n>1 then TabGrid1.SetSelectCol(n,True);
    end;
  ListeSelection.Free;
  ColoreMatrice;
end;
procedure TFormParente.RetracerArbre(BranchesCreuses:Boolean);
begin
  ArbreClade.BranchesCreuses:=BranchesCreuses;
  ArbreClade.Redessine;
end;
procedure TFormParente.Corriger;    //version ancienne mais peut-tre meilleure
Var
  i,n,nb,nbp:integer;
  chaine:string;
  erreur:boolean;
begin
  FicheEssai.LCarac.RowCount:=Mouchard.Count+1;
  for i:=0 to Mouchard.Count-1 do
    begin
      erreur:=false;
      chaine:=Mouchard[i];
      if chaine[1]='*' then
        begin
          FicheEssai.LCarac.AffichCell[0,i+1]:=AfImpos;
          FicheEssai.LCarac.AffichCell[1,i+1]:=AfImpos;
          erreur:=true;
          delete(chaine,1,1);
        end
      else  if chaine[1]='-' then
        begin
          erreur:=true;
          FicheEssai.LCarac.AffichCell[0,i+1]:=AfMoins;//AfD;
          FicheEssai.LCarac.AffichCell[1,i+1]:=AfMoins;//AfD;
          delete(chaine,1,1);
        end
      else
        begin
          FicheEssai.LCarac.AffichCell[0,i+1]:=AfOK;
          FicheEssai.LCarac.AffichCell[1,i+1]:=AfOK;
        end;
      n:=StrToInt(chaine);
      nb:=NbTaxEtatDeriv[n];
      FicheEssai.LCarac.Cells[0,i+1]:=LaSousCollection.Caracteres.GetNomCarD(n);
      FicheEssai.LCarac.Cells[1,i+1]:=IntToStr(nb);
      if i>0 then
        begin
          nbp:=StrToInt(FicheEssai.LCarac.Cells[1,i]);
          if (nb>nbp) and not Erreur then
            begin
              FicheEssai.LCarac.AffichCell[0,i+1]:=AfErr;
              FicheEssai.LCarac.AffichCell[1,i+1]:=AfErr;
            end;
        end
      else if (nb<MaxiTaxEtatDeriv) and (not Erreur) then
        begin
          FicheEssai.LCarac.AffichCell[0,i+1]:=AfErr;
          FicheEssai.LCarac.AffichCell[1,i+1]:=AfErr;
        end;
    end;
  FicheEssai.Suggestions:=false;
  FicheEssai.Label1.Caption:='Ordre logique par rapport au prcdent';
  FicheEssai.Label2.Caption:='Ordre peu logique par rapport au prcdent';
  FicheEssai.AjusteTableau;
  FicheEssai.Show;
end;


{procedure TFormParente.Corriger;         //autre version qui pose problme
Var
  i,n,nb,j,prj,dj,k:integer;
  chaine:string;
  erreur:boolean;
  SugAFaire:Boolean;
  rang:integer;
  stSg:string;
  nouveau:boolean;
  trouve:boolean;
begin
  FicheEssai.LCarac.RowCount:=Mouchard.Count+1;
  FicheEssai.AjusteTableau;
  FicheEssai.Suggestions:=true;
  FicheEssai.Label1.Caption:='Ordre logique';
  FicheEssai.Label2.Caption:='Ordre peu logique par rapport  l''ensemble';
  if FicheEssai.LCarac.ColCount=3 then
    For i:=1 to FicheEssai.LCarac.RowCount-1 do
      FicheEssai.LCarac.cells[2,i]:='';
  SugAFaire:=True;
  rang:=0;
  for i:=0 to Mouchard.Count-1 do
    begin
      erreur:=false;
      chaine:=Mouchard[i];
      if chaine[1]='*' then
        begin
          FicheEssai.LCarac.AffichCell[0,i+1]:=AfImpos;
          FicheEssai.LCarac.AffichCell[1,i+1]:=AfImpos;
          erreur:=true;
          delete(chaine,1,1);
          n:=StrToInt(chaine);
          nb:=NbTaxEtatDeriv[n];
          FicheEssai.LCarac.Cells[0,i+1]:=LaSousCollection.Caracteres.GetNomCarD(n);
          FicheEssai.LCarac.Cells[1,i+1]:=IntToStr(nb);
        end
      else  if chaine[1]='-' then
        begin
          erreur:=true;
          FicheEssai.LCarac.AffichCell[0,i+1]:=AfMoins;
          FicheEssai.LCarac.AffichCell[1,i+1]:=AfMoins;
          delete(chaine,1,1);
          n:=StrToInt(chaine);
          nb:=NbTaxEtatDeriv[n];
          FicheEssai.LCarac.Cells[0,i+1]:=LaSousCollection.Caracteres.GetNomCarD(n);
          FicheEssai.LCarac.Cells[1,i+1]:=IntToStr(nb);
          if rang>0 then dec(rang);
        end
      else
        begin
          n:=StrToInt(chaine);
          nb:=NbTaxEtatDeriv[n];
          FicheEssai.LCarac.Cells[0,i+1]:=LaSousCollection.Caracteres.GetNomCarD(n);
          FicheEssai.LCarac.Cells[1,i+1]:=IntToStr(nb);
          if nb<ValeurRef[rang] then
            begin
              FicheEssai.LCarac.AffichCell[0,i+1]:=AfErr;
              FicheEssai.LCarac.AffichCell[1,i+1]:=AfErr;
              if FicheEssai.Suggestions and SugAFaire then
                begin
                  stSg:=ListeType[rang]; // verifier qu'il n'est pas dja l
                  j:=rang;
                  prj:=-1;
                  dj:=rang;
                  For j:=0 to ListeType.Count-1 do
                    begin
                      if (prj<0) and (ValeurRef[j]=ValeurRef[rang]) then prj:=j;
                      if (ValeurRef[j]=ValeurRef[rang]) then dj:=j
                      else if ValeurRef[j]<ValeurRef[rang] then break;
                    end;
                  For j:=prj to dj do
                    begin
                      nouveau:=true;
                      for k:=1 to i-1 do
                        begin
                          if ListeType[j]=FicheEssai.LCarac.Cells[0,k] then
                            begin
                              nouveau:=false;
                              break;
                            end;
                        end;
                      if nouveau then
                        begin
                          StSg:=ListeType[j];
                          break;
                        end;
                    end;
                  if Not Nouveau then StSg:='Tout dslectionner';
                 FicheEssai.LCarac.Cells[2,i+1]:=StSg;
                  SugAFaire:=False;
                end;
            end
          else
            begin
              FicheEssai.LCarac.AffichCell[0,i+1]:=AfOK;
              FicheEssai.LCarac.AffichCell[1,i+1]:=AfOK;
              FicheEssai.LCarac.Cells[2,i+1]:='Bravo !';
            end;
          inc(rang);
        end;
    end;
  FicheEssai.AjusteTableau;
  FicheEssai.Show;
end;  }
function TFormParente.rechercherEtatPrimitif( caractere :String): string;
var
  LeCaractereD:TCaractD;
begin
  Result:='';
  LeCaractereD:=LaSousCollection.LeCarD(caractere);
  if (LeCaractereD<>Nil) then
    begin
      Result:=LeCaractereD.ListeEtats[0];
      if LeCaractereD.TypeCarD>0 then //si ordonn mais pb avec les .cod par dfaut
        begin
        end
    end;
end;
//** voir si il faut dfinir l'tat driv comme celui de rang 1 ou celui de dernier rang  avec le problme des ?
procedure TFormParente.RechercherEtatDerives( caractere :String);
var
  LeCaractereD:TCaractD;
  i:integer;
  etat:string;
begin
  EtatsDerives.Clear;
  LeCaractereD:=LaSousCollection.LeCarD(caractere);
  if (LeCaractereD<>Nil) then
    begin
      For i:=1 to LeCaractereD.ListeEtats.Count-1 do
        begin
          etat:=LeCaractereD.ListeEtats[i];
          if (trim(etat)<>'?')and (trim(etat)<>'') then EtatsDerives.Add(etat);
        end;
    end;
end;
{procedure TFormParente.SimplifieMouchard;
Var
  i,j:integer;
begin
  MouchardSimplifie.Clear;
  MouchardSimplifie.AddStrings((Mouchard);
  i:=0;
  While i<MouchardSimplifie.Count do
    begin
      chaine:=MouchardSimplifie[i];
      if chaine[1]='*' then MouchardSimplifie.Delete(i)
      else if chaine[1]='-' then
        begin
          Delete(chaine,1,1);
          MouchardSimplifie.Delete(i);
          for j:=i-1 downto 0 do
            begin
              if MouchardSimplifie[j]=chaine then
                begin
                  MouchardSimplifie.Delete(j);
                  dec(i);
                  break;
                end;
            end;
        end;
      else inc(i);
    end;
end;}

procedure TFormParente.RejoueMouchard;
Var
  i,dRAZ,numcarD,col:integer;
  chaine:string;
  MouchardSimplifie:TStringList;
  LeCaractD:TCaractD;
Begin
  //SimplifieMouchard;
  dRAZ:=-1;
  For i:=0 to Mouchard.Count-1 do
    if Mouchard[i]='RAZ' then  dRAZ:=i;

  MouchardSimplifie:=TStringList.Create;
  MouchardSimplifie.Clear;
  For i:=dRAZ+1 to Mouchard.Count-1 do
    begin
      chaine:=Mouchard[i];
      if chaine[1]<>'*' then
        MouchardSimplifie.Add(Chaine);
    end;
  Mouchard.Clear;
  For i:=0 to MouchardSimplifie.Count-1 do
    begin
      chaine:=MouchardSimplifie[i];
      if chaine[1]<>'-' then numCarD:=StrToInt(chaine)
      else numCarD:=StrToInt(copy(chaine,2,Length(chaine)-1));
      LeCaractD:=LaSousCollection.CarD[numCarD];
      col:=TabGrid1.Rows[0].IndexOf(LeCaractD.Nom);
      if (col>0) and (col<TabGrid1.ColCount) then
        TabGrid1ClicCaractere(col);
    end;
  MouchardSimplifie.Free;
end;

procedure TFormParente.afficheArbre; // affichage de l'arbre ajout JFM 12/04/08
Var
 // ListArray:TStrListArray;
  LaRacine,LaBranche:TBranche;
  LaBoite:TBoiteLayer;
  ChaineStruct:string;
  i:integer;  //,j
  //ListeTaxons:TStringList;
  //NomTaxon:string;
begin
  if ArbreAffichable then //and ArbreDisponible
    begin

      // **** srement  supprimer
      if LaSousCollection.Caracteres.CodesEtats=nil then
        begin
          LaSousCollection.Caracteres.CreeCodeSEtats;
        end;
     // **** fin de zone  supprimer

      ChaineStruct:=GrapheBoite.StructBoite;
      While Pos('<>',ChaineStruct)>0 do
        Delete(ChaineStruct,Pos('<>',ChaineStruct),2);
      ArbreClade.ToutEffacer;
      if ChaineStruct<>'' then
        begin
          ArbreClade.Construit(Nil,ChaineStruct,1,'<','>');
        end;
      ArbreClade.CouleurAncetre:=Color32(CouleurAncHorsGroupe);
      ArbreClade.RazCouleurs;
      ArbreClade.ListeCaracteres.Clear;
      for i:=TabGrid1.FixedCols to TabGrid1.ColCount-1 do
        begin
          if TabGrid1.SelectCol[i] then
            ArbreClade.ListeCaracteres.Add(TabGrid1.Cells[i,0]);
        end;
      ArbreClade.ConstruitPortraits(1);   //0
      For i:=0 to Length(ArbreClade.Racines)-1 do
        begin
          LaRacine:=ArbreClade.Racines[i];
          if LaRacine<>Nil then
            begin
              Verifierarbre;
              VerifieTypeRacine; //la racine fictive est-elle dessine dans ce cas ?
              if RacineSansCarDerive then
                begin
                  LaRacine.CouleurAncetre:=Color32(CouleurAncetreRacine);
                  LaRacine.TracerBoite:=False;
                  LaRacine.RacineFictive:=True;
                end
              else LaRacine.TracerBoite:=True;
              //ArbreClade.LargeurDisponible:=ScrollBoxArbre.Width-9; //Client
              //ArbreClade.HauteurDisponible:=ScrollBoxArbre.Height-9; //Client
            end;
        end;
      For i:=0 to Length(GrapheBoite.Boites)-1 do
        begin
          LaBoite:=GrapheBoite.Boites[i];
          if LaBoite<>Nil then
            begin
              LaBranche:=ArbreClade.LAncetreDesTaxons(LaBoite.ListeComplete.CommaText);
              if LaBranche<>Nil then
                LaBranche.CouleurBoite:=LaBoite.CouleurBandeau;
            end;
        end;
      ArbreClade.LargeurDisponible:=ScrollBoxArbre.ClientWidth-1;//
      ArbreClade.HauteurDisponible:=ScrollBoxArbre.ClientHeight-1;
      ArbreClade.Redessine;
      Application.ProcessMessages;
      ArbreClade.Redessine;
      //PanelInfo.Caption:=IntToStr(arbreclade.Bitmap.Height)+' support : '+ intToStr(ScrollBoxArbre.Height);
     // ScrollBoxArbreResize(Self);
      BDater.Visible:=(Pos('D',LaSousCollection.Exclusions)=0);
    end
  else
    begin
      ArbreClade.ToutEffacer;
      ArbreClade.Redessine;
      BDater.Visible:=False;
    end;
end;
function TFormParente.ArbreAffichable:boolean;
Var
  i: integer;
begin
  Result:=False;
  for i:=1 to TabGrid1.ColCount-1 do
    begin
      if TabGrid1.SelectCol[i]=true then
        result:=true;
    end;
  AvertisArbre.Visible:=Not Result;
end;

procedure TFormParente.VerifieTypeRacine;
var
  i,j,p:integer;
  trouve:boolean;
  NomCar:string;
  LeCaracD:TCaractD;
begin
  RacineSansCarDerive:=False;
  for i:=1 to TabGrid1.ColCount-1 do
    begin
      trouve:=false;
      NomCar:=TabGrid1.Cells[i,0];
      LeCaracD:=LaSousCollection.LeCarD(NomCar);
      if LeCaracD<>Nil then
        begin
          for j:=1 to TabGrid1.RowCount-1 do
            begin
              p:=LeCaracD.ListeEtats.IndexOf(TabGrid1.Cells[i,j]);
              if p>0 then
                begin
                  trouve:=true;
                  break;
                end;
            end;
          if not trouve then
            begin
              RacineSansCarDerive:=True;
              break;
            end;
        end;
    end;
end;

procedure TFormParente.TabGrid1ClicCaractere(col:integer);
Var
  AName:string;
  numCar,j:integer;
  UnAffichage:TAffichCell;
  UnCarD:TCaractD;
begin
  if TabGrid1.SelectCol[col]=false then    // La fonction selfMouseDown met  false une cellule
    begin                                  // sur laquelle on a cliqu : c'est parce que pour les
      AName:=TabGrid1.Cells[col,0];      // arbres les cellules sont slectionnes d'emble
      numCar:=LaSousCollection.Caracteres.GetNumCarD(AName);
      if numCar<0 then exit;
      UnCarD:=LaSousCollection.LeCarD(AName);
      RechercherEtatDerives(AName);
      {for i:=0 to 0 do //EtatsDerives.Count-1 do     // pour l'instant uniquement l'tat driv  de niveau 1
        begin }                                       //ce serait plutt aux boites de grer
          //etat:=EtatsDerives[0];
      if AjouterBoite(Aname,Color32(CoulColCarct[numCar])) then
        begin
          TabGrid1.SelectCol[col]:=true;  // jfr modifie le 06/09/00
          //TabGrid1.invalidate;            // jfr modifie le 06/09/00
          for j:=1 to TabGrid1.RowCount-1 do                //ajout JFM 16/06/08
            if  TabGrid1.AffichCell[col,j].Active then
              begin
                UnAffichage:=TabGrid1.AffichCell[col,j];
                UnAffichage.CouleurContour:=CoulColCarct[numCar];
                TabGrid1.AffichCell[col,j]:=UnAffichage;
              end;
          TabGrid1.invalidate;
            //Application.ProcessMessages;
          if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
          if Not PanRejouer.Visible then
            Mouchard.Add(IntToStr(numCar)); //ajoute le numro du caractreD au mouchard
              //Mouchard.Add(IntToStr(col)); //ajoute le numro de colonne au mouchard
        end
      else
        begin
          if Not PanRejouer.Visible then
            Mouchard.Add('*'+IntToStr(numCar)); //ajoute -numro du caractreD au mouchard  pour signaler l'erreur
        end;
    end
  else                // Tout se passe comme si le caractre tait dj slectionn et donc avait dj particip  la construction de boites
    begin
      AName:=TabGrid1.Cells[col,0];
      numCar:=LaSousCollection.Caracteres.GetNumCarD(TabGrid1.Cells[col,0]);
      //Mouchard.Add('-'+IntToStr(col)); //ajoute  -numro de colonne au mouchard pour signaler le retour en arrire
      if Not PanRejouer.Visible then
        Mouchard.Add('-'+IntToStr(numCar)); //ajoute -numro du caractreD au mouchard  pour signaler le retour en arrire

      GrapheBoite.RetireBoitesContenant(AName);
      TabGrid1.SelectCol[col]:=false;  // jfr modifie le 06/09/00
      for j:=1 to TabGrid1.RowCount-1 do
        if TabGrid1.AffichCell[col,j].Active then
          begin
            UnAffichage:=TabGrid1.AffichCell[col,j];
            UnAffichage.CouleurContour:=clBlack;
            TabGrid1.AffichCell[col,j]:=UnAffichage;
          end;
      TabGrid1.invalidate;            // jfr modifie le 06/09/00
      if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
    end;
end;
function TFormParente.AjouterBoite(LeCaractere:String;Couleur:TColor32):Boolean;
var
  col,nb,i,j,n:integer;
  etat,etatTax:String;
  NomTaxon:string;
  UnCarD:TCaractD;
  SesTaxons,SesEtats,SesnomsAffich,LaListeN,LaListeNA:TStringList;
  Couleurs:Array of TColor32;
  TexteMess:string;
  primitif,condition:Boolean;
begin
  col :=  Tabgrid1.Rows[0].IndexOf(LeCaractere);    // index de la colonne qui contient le caractre slectionn dans la grille des donnes
  nb := Tabgrid1.rowcount;
  primitif:=True;
  for i:=1 to nb-1 do    // vrification que le caractere n'est pas  l'tat primitif partout
    begin
      etat := trim(Tabgrid1.Cells[col,i]);
      if (etat <> '') then
        begin
          n:=EtatsDerives.IndexOf(etat);
          if n>-1 then
            begin
              primitif:=false;
              break;
            end;
        end;
    end;
  if primitif then
    begin
      result:=False;
      if LaSousCollection.FModeCollege then
        TexteMess:='Cration d''une nouvelle boite impossible : le caractre est absent chez toutes les espces'
      else
        TexteMess:='Cration d''une nouvelle boite impossible car tous les taxons prsentent l''tat primitif du caractre';
      MessageDlg(TexteMess,mtWarning,[mbOK],0);
      exit ;
    end;
  //Sinon, essayer de creer des nouvelles botes (une par tat driv)
  SesEtats:=TStringList.Create;
  SesTaxons:=TStringList.Create;
  SesnomsAffich:=TStringList.Create;
  LaListeN:=TStringList.Create;
  LaListeNA:=TStringList.Create;
  Result:=True;
  UnCarD:=LaSousCollection.LeCarD(LeCaractere);
  If UnCarD=Nil Then
    Result:=False
  else
    begin
      For i:=1 to UnCarD.ListeEtats.Count-1 do
        begin
          etat:=UnCarD.ListeEtats[i];
          if etat<>'?' then
            begin
              SesEtats.Add(etat);
              LaListeN.Clear;
              LaListeNA.Clear;
              For j:=TabGrid1.FixedRows to Tabgrid1.RowCount-1 do
                begin
                  NomTaxon:=trim(Tabgrid1.Cells[0,j]);
                  etatTax:=LaSousCollection.EtatDe(NomTaxon,LeCaractere,n);
                  Condition:=(etatTax=etat);
                  Condition:=Condition or((UnCarD.TypeCarD=1)and(etatTax<>'?')and (n>i));
                  if Condition then
                    begin
                      LaListeN.Add(NomTaxon);
                      if LaSousCollection.EstFossileNm(NomTaxon) then
                        LaListeNA.Add(NomTaxon+' '+LaSousCollection.AgeStrNm(NomTaxon))
                      else
                        LaListeNA.Add(NomTaxon);
                    end;
                end;
              If LaListeN.Count>0 then
                begin
                  SesTaxons.Add(LaListeN.CommaText);
                  SesnomsAffich.Add(LaListeNA.CommaText);
                end
              else
                begin
                  SesEtats.Delete(SesEtats.Count-1);
                end;
            end;
        end;
      if SesEtats.Count>0 then
        begin
          SetLength(Couleurs,SesEtats.Count);
          For i:=0 to Length(Couleurs)-1 do
            Couleurs[i]:=Couleur;
          Result:=GrapheBoite.CreeEtPlaceBoites(LeCaractere,SesTaxons,SesEtats,SesnomsAffich,Couleurs);
        end
      else
        Result:=False;
    end;
  if Result=False then
    begin
      if LaSousCollection.FModeCollege then
        TexteMess:='Cration d''une nouvelle boite impossible : les espces qu''elle contiendrait appartiennent dj  des boites diffrentes'
      else
        TexteMess:='Cration d''une nouvelle boite impossible car les taxons qu''elle contiendrait appartiennent dj  des boites diffrentes';
      MessageDlg(TexteMess,mtWarning,[mbOK],0);
    end;
  SesTaxons.Free;      
  SesEtats.Free;
  SesnomsAffich.Free;
  LaListeN.Free;
  LaListeNA.Free;
end;

procedure TFormParente.TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  col,row,j,numCar:integer;  
  AName:string;
  etat: string ;
  UnAffichage:TAffichCell;
  NomTaxon:string;
  NomCaractere:string;
  LeCarD:TCaractD;
  couleurBoite:TColor;
begin
  TabGrid1.MouseToCell(X,Y,col,row);
  if (col=0) and (Row>0) and (Not ActiverLeDeplacement.Checked) then
    begin
      NomTaxon:=TabGrid1.Cells[0,Row];
      AfficheDocs.AfficheTaxon(NomTaxon);
    end;
  if (ssRight in Shift)  or BDocs.Down then    // clic droit
    begin
      if (Row>0) then
        begin
          if col>0 then
            begin
               // remplacer par un AffichTaxonCaracD qui affiche les docs du taxon
                 // + l'image qui prsente l'tat du caractD chez ce Taxon
              NomTaxon:=TabGrid1.Cells[0,Row];
              NomCaractere:=TabGrid1.Cells[Col,0];
              etat:=TabGrid1.Cells[Col,Row];
              //AfficheDocs.AfficheTaxonEtCarD(NomTaxon,NomCaractere,etat);
              AfficheDocs.AfficheCarD(NomTaxon,NomCaractere,etat);
            end
          else
            begin
              NomTaxon:=TabGrid1.Cells[0,Row];
              AfficheDocs.AfficheTaxon(NomTaxon);
            end;
          exit;
        end
      else if col>0 then
        begin
          NomCaractere:=TabGrid1.Cells[Col,0];
          AfficheDocs.IllustreEtats(NomCaractere);
          exit;
        end;
    end;
  if DeplacementPossible then exit;
  if (row=0) and (col<>0) and (button=mbleft) then   // (button=mbleft) rajout le 12/01
    begin
      numCar:=LaSousCollection.Caracteres.GetNumCarD(TabGrid1.Cells[col,0]);
      if numCar>-1 then LeCarD:=LaSousCollection.CarD[numCar];
      ArbreClade.HauteurDisponible:=ScrollBoxArbre.ClientHeight;

      if TabGrid1.SelectCol[col]=false then    // La fonction selfMouseDown met  false une cellule
        begin                                  // sur laquelle on a cliqu : c'est parce que pour les
          AName:=TabGrid1.Cells[col,row];      // arbres les cellules sont slectionnes d'emble
          rechercherEtatDerives( AName); // le rsultat de la recherche est mis dans le StringList EtatsDerives
          etat:= EtatsDerives[0];
          if (numCar=-1) or (LeCarD=Nil) then exit;
          couleurBoite:=CoulColCarct[numCar];
          //CouleursCaractDBoites[numCar mod Length(CouleursCaractDBoites)];
          if AjouterBoite(Aname,Color32(couleurBoite)) then
            begin
              TabGrid1.SelectCol[col]:=true;  // jfr modifie le 06/09/00
              for j:=1 to TabGrid1.RowCount-1 do                //ajout JFM 16/06/08
                if  TabGrid1.AffichCell[col,j].Active then
                  begin
                    UnAffichage:=TabGrid1.AffichCell[col,j];
                    UnAffichage.CouleurContour:=CoulColCarct[numCar];
                    TabGrid1.AffichCell[col,j]:=UnAffichage;
                  end;
              TabGrid1.invalidate;            // jfr modifie le 06/09/00

              Application.ProcessMessages;
              if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
              //Mouchard.Add(IntToStr(col)); //ajoute le numro de colonne au mouchard
              if Not PanRejouer.Visible then
                Mouchard.Add(IntToStr(numCar)); //ajoute le numro du caractreD au mouchard
            end
          else
            begin
              //Mouchard.Add('*'+IntToStr(col)); //ajoute *+numro de colonne au mouchard pour signaler l'erreur
              if Not PanRejouer.Visible then
                Mouchard.Add('*'+IntToStr(numCar)); //ajoute *+numro du caractreD au mouchard  pour signaler l'erreur
            end;
        end
      else                // Tout se passe comme si le caractre tait dj slectionn et donc avait dj particip  la construction de boites
        begin
          AName:=TabGrid1.Cells[col,row];
          //Mouchard.Add('-'+IntToStr(col)); //ajoute  -numro de colonne au mouchard pour signaler le retour en arrire
          if Not PanRejouer.Visible then
            Mouchard.Add('-'+IntToStr(numCar)); //ajoute -numro du caractreD au mouchard  pour signaler le retour en arrire

          GrapheBoite.RetireBoitesContenant(AName);

          RechercherEtatDerives( AName);

          TabGrid1.SelectCol[col]:=false;  // jfr modifie le 06/09/00
          TabGrid1.invalidate; // jfr modifie le 06/09/00
          for j:=1 to TabGrid1.RowCount-1 do
            if  TabGrid1.AffichCell[col,j].Active then
              begin
                UnAffichage:=TabGrid1.AffichCell[col,j];
                UnAffichage.CouleurContour:=clBlack;
                TabGrid1.AffichCell[col,j]:=UnAffichage;
              end;
          if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08

        end;
    end;
  if (row=0) and (col<>0) and (button=mbright) then   // (button=mbright) rajout le 10/09/00
    begin
      if TabGrid1.SelectCol[col]=false then TabGrid1.SelectCol[col]:=true
      else TabGrid1.SelectCol[col]:=false;
    end;
  splitter1.Cursor:=crVSplit;
  Splitter2.Cursor:=crHSplit;
end;

procedure TFormParente.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //FormPrinc.AClasse:=nil;
  //GraphTri21.ChangeGraphObjects;
  //TabGrid1.SelectAllCol(false);
  //ArbreDisponible:=True;
  FormPrinc.EnregistrerBoites.Enabled:=False;
end;
procedure TFormParente.CalculeListeRef;
Var
  LeCarD:TCaractD;
  //NumCarD:integer;
  i,j,n,k,nbp:integer;
  premNum:integer;
  valeur:integer;
begin
  //  Calcul de  MaxiTaxEtatDeriv et des NbTaxEtatDeriv // nombre maxi de taxons tant  l'tat driv pour un caractre
  MaxiTaxEtatDeriv:=0;
  ListeType.Clear;
  SetLength(NbTaxEtatDeriv,LaSousCollection.Caracteres.CarDs.NbCarD);
  for i:=0 to LaSousCollection.Caracteres.CarDs.NbCarD-1 do
    begin
      LeCarD:=LaSousCollection.CarD[i];
      n:=TabGrid1.Rows[0].IndexOf(LeCarD.Nom);
      if n>0  then
        begin
          NbTaxEtatDeriv[i]:=0;
          ListeType.Add(LeCarD.Nom);
{          for j:=1 to TabGrid1.RowCount-1 do
            begin
              if (TabGrid1.Cells[n,j]<>'?') and (LeCarD.ListeEtats.IndexOf(TabGrid1.Cells[n,j])>0) then
              NbTaxEtatDeriv[i]:=NbTaxEtatDeriv[i]+1;
            end;
}         // compter par tats et prendre le plus fort nombre
          for k:=1 to LeCarD.ListeEtats.Count-1 do
            begin
              if LeCarD.ListeEtats[k]<>'?' then
                begin
                  nbp:=0;
                  for j:=1 to TabGrid1.RowCount-1 do
                    if TabGrid1.Cells[n,j]=LeCarD.ListeEtats[k] then inc(nbp);
                  if nbp>NbTaxEtatDeriv[i] then NbTaxEtatDeriv[i]:=nbp;
                end;
            end;
          
          if NbTaxEtatDeriv[i]>MaxiTaxEtatDeriv then
            begin
              MaxiTaxEtatDeriv:=NbTaxEtatDeriv[i];
              CarMaxTaxED:=LeCarD.Nom;
            end;
        end
      else NbTaxEtatDeriv[i]:=0;
    end;
  premNum:=0;//mise en ordre de la liste
  valeur:=MaxiTaxEtatDeriv;
  SetLength(ValeurRef,ListeType.Count);
  while (premNum<ListeType.Count)and(valeur>-1) do
    begin
      for i:=premNum to ListeType.Count-1 do
        begin
          n:=LaSousCollection.Caracteres.GetNumCarD(ListeType[i]);
          if n>-1 then
            begin
              if NbTaxEtatDeriv[n]=valeur then
                begin
                  ListeType.Move(i,premNum);
                  ValeurRef[premNum]:=valeur;
                  inc(premNum);
                end;
            end;
        end;
      Dec(Valeur);
    end;
end;
procedure TFormParente.ChargeTabGrid;
var
  ListArray: TStrListArray;
  ListAges:TStrListArray;
  //node : TNodeBoite;
  i,j,nbp,numetat,numCarD,numCarDj :integer; //row,n,
  carac,etat :string; //taxon,
  profils:Array of string;
  LeCarD:TCaractD;
  //NumCar:integer;
  absent:boolean;
begin
  //FormPrinc.AClasse:=nil;
  TabGrid1.SelectAllCol(false);
  //if FormPrinc.AClasse = nil then
  //  begin
  BDater.Visible:=False;
      DeplacementPossible:=False;
      Mouchard.Clear;
      ListArray:=FormPrinc.AData;
      if ListArray=nil then
        begin
          ListArray:=TStrListArray.createlistArray;
          FormPrinc.AData:=ListArray;
        end;

      if (ListArray.RowCount<2) or  (ListArray.GetMaxColCount<2) then
        begin
          if TableauCorrect then
            FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray)
          else
            ListArray.Assign(LaSousCollection.TabRef);
        end;
      TabGrid1.RowCount:=ListArray.RowCount;
      TabGrid1.ColCount:=ListArray.GetMaxColCount;
      TabGrid1.copyFromAlistArray(0,0,ListArray);
      TabGrid1.AdjustColWidths;

      ListAges:=LaSousCollection.CreeTabAges(ListArray);
      GrapheBoite.RaZBoites;
      ListeTaxonsActifs.clear;
      For i:=TabGrid1.FixedRows to TabGrid1.RowCount-1 do
        begin
          ListeTaxonsActifs.Add(TabGrid1.Cells[0,i]);
        end;
      //FormPrinc.AClasse:= Nil;    //


      TabGrid1.Invalidate;
      // **** srement  supprimer
      if LaSousCollection.Caracteres.CodesEtats=nil then
        begin
          LaSousCollection.Caracteres.CreeCodeSEtats
        end;
      TabGrid1.FTabCod:=LaSousCollection.Caracteres.CodesEtats;
     // **** fin de zone  supprimer

      //Ajustement des couleurs correspondant aux caractres
      SetLength(CoulColCarct,LaSousCollection.Caracteres.CarDs.NbCarD);
      for i:=0 to Length(CoulColCarct)-1 do CoulColCarct[i]:=clGray;
      nbp:=0;
      setLength(profils,TabGrid1.ColCount-1);
      For i:=0 to TabGrid1.ColCount-2 do
        begin
          absent:=true;
          profils[i]:='';
          Carac:=TabGrid1.Cells[i+1,0];
          numCarD:=LaSousCollection.Caracteres.GetNumCarD(Carac);
          if numCarD>-1 then
            begin
              for j:=1 to TabGrid1.RowCount-1 do
                begin
                  etat:=TabGrid1.Cells[i+1,j];
                  LeCarD:=LaSousCollection.CarD[numCarD];
                  numetat:=LeCarD.ListeEtats.IndexOf(etat);
                  profils[i]:=profils[i]+IntToStr(numetat);
                end;
              for j:=0 to i-1 do
                begin
                  if profils[i]=profils[j] then
                    begin
                      numCarDj:=LaSousCollection.Caracteres.GetNumCarD(TabGrid1.Cells[j+1,0]);
                      CoulColCarct[numCarD]:=CoulColCarct[numCarDj];
                      absent:=false;
                      break;
                    end;
                end;
              if absent then
                begin
                  //if pos('0',profils[i])>0 then
                  //  begin
                      CoulColCarct[numCarD]:=CouleursCaractDBoites[nbp mod Length(CouleursCaractDBoites)];
                      inc(nbp);
                 //   end
                 // else CoulColCarct[numCarD]:=clWhite;
                end;
            end;
        end;
      setLength(profils,0);
      //  Ajustement des taxons slectionns
      For i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
        TTaxon(LaSousCollection.Taxons[i]).Selected:=(TabGrid1.Cols[0].IndexOf(TTaxon(LaSousCollection.Taxons[i]).Nom)>-1);
      CalculeListeRef;

      // recherche des cases  colorer
      ColoreMatrice;
      GroupeANommer.Clear;
      NumeroGroupe:=-1;

      PanelGrille.Height:=Min(Round(FormParente.Height/1.5),TabGrid1.RowCount*(TabGrid1.DefaultRowHeight+1)+24);
      If PanelGrille.Height<(Bdater.Top+BDater.Height+5) then PanelGrille.Height:=(Bdater.Top+BDater.Height+5);
      //If PanelGrille.Height<(PanelBoutons.Top+PanelBoutons.Height+5) then PanelGrille.Height:=(PanelBoutons.Top+PanelBoutons.Height+5);
      PanelArbre.Width:=FormParente.Width div 3;
      LaSouscollection.MesCarD:=LaSouscollection.Caracteres.CarDs;
      ArbreClade.LaSousCollection:=LaSousCollection;
      ScrollBoxArbreResize(self);
      AfficherGroupes.Checked:=False;
      AfficherTaxons.Checked:=True;
      AfficherTaxons.Enabled:=False;
      AfficherGroupes.Enabled:=False;
      AfficherGroupes.Visible:=LaSousCollection.GroupesDeclares;

    //end;
end;

procedure TFormParente.FormCreate(Sender: TObject);
begin
   FormPrinc.Fille(Self);
   RacineSansCarDerive:=False;
   EtatsDerives:=TStringList.Create;
   ListeType:=TStringList.Create;
   ListeTaxonsActifs:=TStringList.Create;
   TabGrid1.InactiverDroit:=True;
   //ArbreDisponible:=True;
   Panel4.Caption:='prsent';
   Label1.Caption:='caractre prsent'; //+chr(13)+'chez l''espce'
  ChangeSupport(False);

   PanelGrille.Height:=PanelBoutons.Top+PanelBoutons.Height+5;//Round(Height/1.5);

   GrapheBoite:=TGrapheBoite.Create(ScrollBoxBoites);
   GrapheBoite.parent:=ScrollBoxBoites;
   GrapheBoite.Align:=alNone;
   GrapheBoite.Left:=0;
   GrapheBoite.Top:=0;
   GrapheBoite.Fige:=True;
   GrapheBoite.OnMouseDown:=GrapheBoiteMouseDown;
   GrapheBoite.OnMouseUp:=GrapheBoiteMouseUp;

   ArbreClade:=TArbreDate.Create(ScrollBoxArbre);
   ArbreClade.parent:=ScrollBoxArbre;
   ArbreClade.Align:=alNone;
   ArbreClade.Left:=0;
   ArbreClade.Top:=0;
   ArbreClade.TypeDArbre:=1;
   ArbreClade.EstModifiable:=False;
   ArbreClade.UneBrancheEstCliquee:=AncetreClique;
   ArbreClade.UnGroupeEstANommer:=UnGroupeEstANommer;

   ArbreClade.AjusterInfo:=AjusterInfo;
   ArbreClade.OnMouseUp:=ArbreCladeMouseUp;
   ArbreClade.OnMouseDown:=ArbreCladeMouseDown;
   //ArbreClade.MontrerAncetre:=True;
   ArbreClade.CouleurAncetre:=Color32(CouleurAncHorsGroupe);
   ArbreClade.Height:=ScrollBoxArbre.ClientHeight;
   ArbreClade.Bitmap.Height:=ArbreClade.ClientHeight;
   ArbreClade.LargeurDisponible:=PanelArbre.ClientWidth-12;//
   ArbreClade.HauteurDisponible:=PanelArbre.ClientHeight-41;//
   ArbreClade.MethodeParci:=1;
   //ArbreClade.StyleAncetre:=bsSolid;//bsDiagCross;
   InactiveMouseUp:=False;
   AfDExcl:=ConvertitAffCelAffCoul(ModDeriveExcl);
   AfD:=ConvertitAffCelAffCoul(ModDerive);
   AfA:=ConvertitAffCelAffCoul(ModAncestral);
{   AfDExcl.Active:=True;
   AfDExcl.CouleurFond:=CouleurMisEnEvid;//CouleurAncDesc;
   AfDExcl.CouleurTexte:=ClBlack;
   AfDExcl.styleFond:=bsSolid;
   AfDExcl.CouleurContour:=clBlack;
   AfD:=AfDExcl;
   AfD.CouleurFond:=CouleurAncHorsGroupe;
   AfD.CouleurTexte:=clBlack;
   AfA.Active:=false;}
   AfOK:=AfDExcl;
   AfOK.CouleurFond:=clLime;
   AfImpos:=AfD;
   AfImpos.CouleurFond:=clRed;
   AfMoins:=AfImpos;
   AfMoins.CouleurFond:=clBlue;
   AfErr:=AfDExcl;
   AfErr.CouleurFond:=$00C0FF;
//   CouleurAncetreClique:=ClYellow;
//   CouleurMisEnEvid:=ClYellow;
//   CouleurAncDesc:=ClYellow;
//   CouleurAncetreRacine:=clBlue;
   Mouchard:=TStringList.Create;
   Mouchard.Clear;
   MouchardSimplifie:=TStringList.Create;
   GroupeANommer:=TStringList.Create;
   NumeroGroupe:=-1;
end;

 // jfr modifie le 07/03/02    fonction rajoute
procedure TFormParente.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button=mbright then application.messagebox('Activer la fonction Arbre' , 'Option',mb_ok);
end;

// jfr modifie le 07/03/02    fonction rajoute    Attention  modifier le fichier dfm en appellant cette fonction  travers l'inspecteur d'objet et la proprit on
// onMouseUp de graphtri
procedure TFormParente.GrapheBoiteMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer;Layer:TCustomLayer);
Var
  LaBranche:TBranche;
begin
{if (button=mbright) and PeutAfficherArbre then // Modif JFM 10/04/08
  begin
  if application.messagebox('Activer la fonction Arbre ?' , 'Option',mb_okcancel)=IDOK
    then FormPrinc.Arbre.Enabled:=true;
  end;}
  If Button=mbRight then
    begin
      if NommerBoite and (BoiteANommer<>Nil) then
        begin
          if (MessageDlg('Nommer le groupe correspondant  la bote ?',mtConfirmation,[mbYes,mbNo],0)=mrYes) then
            begin
              FormGroupe.initialise;
              FormGroupe.Groupe.Clear;
              FormGroupe.Groupe.AddStrings(GroupeANommer);
              if (FormGroupe.ShowModal=mrOK) and (FormGroupe.NumeroGroupe>-1) then
                begin
                  NumeroGroupe:=FormGroupe.NumeroGroupe;
                  BoiteANommer.NomGroupe:=GroupeANommer[NumeroGroupe];
                  If panelArbre.Visible then
                    begin
                      LaBranche:=ArbreClade.LAncetreDesTaxons(BoiteANommer.ListeComplete.CommaText);
                      if LaBranche<>Nil then
                        begin
                          LaBranche.NomGroupe:=BoiteANommer.NomGroupe;
                          If Arbreclade.DessinerBoites then
                            Arbreclade.Redessine;
                        end;
                    end;
                  Application.processMessages;
                end;
            end;
          BoiteANommer.SurEncadre:=False;
          GrapheBoite.PositionneBoites;
        end;
    end;
end;
procedure TFormParente.GrapheBoiteMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer;Layer:TCustomLayer);
Var
  LaBoite:TBoiteLayer;
  LeSupport:TRubberbandLayer;
  NomCar,NomEtat,NomGroupe:string;
  LeCarD:TCaractD;
  Groupe:TStringList;
  i:integer;
Begin
  If Button=mbRight then
    begin
      LaBoite:=Nil;
      if Layer=Nil then exit;
      if (Layer is TBoiteLayer) then
        begin
          LaBoite:=TBoiteLayer(Layer);
          LeSupport:=LaBoite.Support;
        end
      else if (Layer is TRubberBandLayer) then
        begin
          LeSupport:=TRubberbandLayer(Layer);
          if (LeSupport.ChildLayer is TBoiteLayer) then
            LaBoite:=TBoiteLayer(LeSupport.ChildLayer);
        end;
      BoiteANommer:=Nil;
      NommerBoite:=False;
      if LaBoite<>Nil then
        if LaBoite.NomGroupe='' then
          begin
            Groupe:=TStringList.Create;
            For i:=0 to LaBoite.Caracteres.Count-1 do
              begin
                NomCar:=LaBoite.Caracteres[i];
                NomEtat:=LaBoite.Etats[i];
                NomGroupe:=LaSousCollection.NomGroupe(NomCar,NomEtat);
                if NomGroupe<>'' then
                   Groupe.Add(NomGroupe);
              end;
            if (Groupe.Count>0)and (Groupe[0]<>'') then
              begin
                LaBoite.SurEncadre:=True;
                LaBoite.CouleurSurCadre:=clBlue32;
                GrapheBoite.Refresh;
                Application.ProcessMessages;
                GroupeANommer.AddStrings(Groupe);
                NommerBoite:=True;
                BoiteANommer:=LaBoite;
              end
            else
              begin
                LaBoite.SurEncadre:=False;
                GrapheBoite.Refresh;
              end;
            Groupe.Free;
          end
        else
          begin
            LaBoite.SurEncadre:=False;
            GrapheBoite.Refresh;
          end;
    end;
end;

procedure TFormParente.AjusterInfo(sender:Tobject);
begin
  PanelInfo.Caption:=Arbreclade.TexteInfo;
end;
procedure TFormParente.UngroupeEstNomme;
begin
  if (LeDernierAncetreClique<>Nil) and (LaBoiteduDernierAncetreClique<>Nil) then
    begin
      LeDernierAncetreClique.NomGroupe:=FicheCarAncetre.Groupe[FicheCarAncetre.NumeroGroupe];
      LaBoiteduDernierAncetreClique.NomGroupe:=FicheCarAncetre.Groupe[FicheCarAncetre.NumeroGroupe];
      GrapheBoite.Redessine;
      FicheCarAncetre.GroupeNomme:=Nil;
    end;
end;
procedure TFormParente.UnGroupeEstANommer(sender:Tobject);
Var
  LeNoeud:TBranche;
  LalisteDerivExcl:TStringList;
  nomcar,nometat,nomTaxon:string;
  i,n:integer;
  LaBoite:TBoiteLayer;
  ListeTaxons:TStringList; //Liste des taxons qui descendent de l'anctre sur lequel on a cliqu
  NomGroupe:string;
  ChaineGroupes:string;
begin
  if ArbreClade.BrancheCliquee.estUnTaxon then
    begin
    end
  else
    begin
      NomTaxon:='';
      LeNoeud:=ArbreClade.BrancheCliquee;
      AjusteActive;
      ListeTaxons:=TStringList.Create;
      ListeTaxons.CommaText:=LeNoeud.TaxonsDescendants;

      if ListeTaxons.Count>0 then
        begin
          FicheCarAncetre.LTaxons.RowCount:= ListeTaxons.Count;
          For i:=0 to ListeTaxons.Count-1 do
            begin
              FicheCarAncetre.LTaxons.Cells[0,i]:=ListeTaxons[i];
            end;
          // fonctionne mais  remplacer comme dans la version lyce
          LalisteDerivExcl:=LaSousCollection.ConstruitListeEtatsAncetre(AfDExcl,AfD,AfA,NomGroupe,ListeTaxons,FicheCarAncetre.ColorStringGrid);
          NomTaxon:=ListeTaxons[0];
          if (LalisteDerivExcl<>nil)and (nomTaxon<>'') then
            begin
              nomcar:='';
              for i:=0 to LalisteDerivExcl.Count-1 do
                begin
                  nomcar:=LalisteDerivExcl[i];
                  nomEtat:=LaSousCollection.EtatDe(NomTaxon,NomCar,n);
                  LaBoite:=GrapheBoite.LaBoite(nomcar,nometat);
                  if LaBoite<>nil then break;
                end;
            end;
          if LaBoite<>Nil then
            LeNoeud.NomGroupe:=LaBoite.NomGroupe;
          if LeNoeud.NomGroupe<>'' then
            begin
              FicheCarAncetre.ModeTrouveGroupe:=false;
              FicheCarAncetre.Groupe.Clear;
              FicheCarAncetre.Groupe.Add(LeNoeud.NomGroupe);
              FicheCarAncetre.NumeroGroupe:=0;
            end
          else
            begin
              ChaineGroupes:=LaSousCollection.LesGroupes(ListeTaxons,ListeTaxonsActifs);
              FicheCarAncetre.NumeroGroupe:=-1;
              if ChaineGroupes<>'' then
                begin
                  FicheCarAncetre.Groupe.CommaText:=ChaineGroupes;
                  FicheCarAncetre.ModeTrouveGroupe:=True;
                end
              else
                begin
                  FicheCarAncetre.ModeTrouveGroupe:=False;
                end;
            end;
          FicheCarAncetre.Caption:='Caractres';
          FicheCarAncetre.PanelNomAnc.Caption:=LeNoeud.Nom;

          FicheCarAncetre.PanAvertis.Visible:=false;
          FicheCarAncetre.PanCoulDExcl.AffichCell[0,0]:=AfDExcl;
          FicheCarAncetre.AjusteLegende;

          FicheCarAncetre.cD:=AfD.CouleurFond;
          FicheCarAncetre.cDE:=AfDExcl.CouleurFond;
          FicheCarAncetre.Classer;
          FicheCarAncetre.Show;
          if (nomcar<>'') and(LaBoite<>nil) then
            begin
              LaBoite.CouleurSurCadre:=Color32(CouleurBranchesGroupe);
              LaBoite.SurEncadre:=True;
              LeDernierAncetreClique:=LeNoeud;
              LaBoiteduDernierAncetreClique:=LaBoite;
              if FicheCarAncetre.ModeTrouveGroupe then
                FicheCarAncetre.GroupeNomme:=UngroupeEstNomme;
              GrapheBoite.Redessine;
            end;
        end;

      InactiveMouseUp:=True;
      GrapheBoite.RAZSurEncadre;
      ArbreClade.RazCouleurs;

      LeNoeud.CouleurSurBoite:=Color32(CouleurBranchesGroupe);
      LeNoeud.FixeCouleurAncetresDescendants(Color32(CouleurNoeudsGroupe));   //noeuds
      LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurBranchesGroupe),False); //entrenoeuds
      LeNoeud.CouleurAncetre:=Color32(CouleurAncetreClique);
      ArbreClade.Redessine;

      if LalisteDerivExcl<>nil then LalisteDerivExcl.Free;
      ListeTaxons.Free;

      Application.ProcessMessages;
      ColoreMatrice;
    end;
end;

procedure TFormParente.AncetreClique(sender:Tobject);
Var
  LeNoeud:TBranche;
  LalisteDerivExcl:TStringList;
  nomcar,nometat,nomTaxon:string;
  i,n:integer;
  LaBoite:TBoiteLayer;
  ListeTaxons:TStringList; //Liste des taxons qui descendent de l'anctre sur lequel on a cliqu
  NomGroupe:string;
  ChaineGroupes:string;
begin
  if ArbreClade.BrancheCliquee.estUnTaxon then
    begin
    end
  else
    begin
      NomTaxon:='';
      LeNoeud:=ArbreClade.BrancheCliquee;
      AjusteActive;
      ListeTaxons:=TStringList.Create;
      ListeTaxons.CommaText:=LeNoeud.TaxonsDescendants;
      FicheCarAncetre.Caption:='Caractres';
      if LeNoeud.NomGroupe<>'' then
        FicheCarAncetre.PanelNomAnc.Caption:='Anctre des '+LeNoeud.NomGroupe
      else
        FicheCarAncetre.PanelNomAnc.Caption:=LeNoeud.Nom;

      if ListeTaxons.Count>0 then
        begin
          FicheCarAncetre.LTaxons.RowCount:= ListeTaxons.Count;
          For i:=0 to ListeTaxons.Count-1 do
            begin
              FicheCarAncetre.LTaxons.Cells[0,i]:=ListeTaxons[i];
            end;
          // fonctionne mais  remplacer comme dans la version lyce
          LalisteDerivExcl:=LaSousCollection.ConstruitListeEtatsAncetre(AfDExcl,AfD,AfA,NomGroupe,ListeTaxons,FicheCarAncetre.ColorStringGrid);
          NomTaxon:=ListeTaxons[0];
          if (LalisteDerivExcl<>nil)and (nomTaxon<>'') then
            begin
              nomcar:='';
              for i:=0 to LalisteDerivExcl.Count-1 do
                begin
                  nomcar:=LalisteDerivExcl[i];
                  nomEtat:=LaSousCollection.EtatDe(NomTaxon,NomCar,n);
                  LaBoite:=GrapheBoite.LaBoite(nomcar,nometat);
                  if LaBoite<>nil then break;
                end;
            end;
          if LaBoite<>Nil then
            LeNoeud.NomGroupe:=LaBoite.NomGroupe;
          if LeNoeud.NomGroupe<>'' then
            begin
              FicheCarAncetre.ModeTrouveGroupe:=false;
              FicheCarAncetre.Groupe.Clear;
              FicheCarAncetre.Groupe.Add(LeNoeud.NomGroupe);
              FicheCarAncetre.NumeroGroupe:=0;
            end
          else
            begin
              ChaineGroupes:=LaSousCollection.LesGroupes(ListeTaxons,ListeTaxonsActifs);
              FicheCarAncetre.NumeroGroupe:=-1;
              if ChaineGroupes<>'' then
                begin
                  FicheCarAncetre.Groupe.CommaText:=ChaineGroupes;
                  FicheCarAncetre.ModeTrouveGroupe:=True;
                end
              else
                begin
                  FicheCarAncetre.ModeTrouveGroupe:=False;
                end;
            end;

          FicheCarAncetre.PanAvertis.Visible:=false;
          FicheCarAncetre.PanCoulDExcl.AffichCell[0,0]:=AfDExcl;
          FicheCarAncetre.AjusteLegende;

          FicheCarAncetre.cD:=AfD.CouleurFond;
          FicheCarAncetre.cDE:=AfDExcl.CouleurFond;
          FicheCarAncetre.Classer;
          FicheCarAncetre.Show;
          if (nomcar<>'') and(LaBoite<>nil) then
            begin
              LaBoite.CouleurSurCadre:=Color32(CouleurBranchesGroupe);
              LaBoite.SurEncadre:=True;
              LeDernierAncetreClique:=LeNoeud;
              LaBoiteduDernierAncetreClique:=LaBoite;
              if FicheCarAncetre.ModeTrouveGroupe then
                FicheCarAncetre.GroupeNomme:=UngroupeEstNomme;
              GrapheBoite.Redessine;
            end;
        end;

      InactiveMouseUp:=True;
      GrapheBoite.RAZSurEncadre;
      ArbreClade.RazCouleurs;

      LeNoeud.CouleurSurBoite:=Color32(CouleurBranchesGroupe);
      LeNoeud.FixeCouleurAncetresDescendants(Color32(CouleurNoeudsGroupe));   //noeuds
      LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurBranchesGroupe),False); //entrenoeuds
      LeNoeud.CouleurAncetre:=Color32(CouleurAncetreClique);
      ArbreClade.Redessine;

      if LalisteDerivExcl<>nil then LalisteDerivExcl.Free;
      ListeTaxons.Free;

      Application.ProcessMessages;
      ColoreMatrice;
    end;
end;

procedure TFormParente.Splitter2CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept:=False;
  if (NewSize>200) and ((Width-NewSize-Splitter2.Width)>99) then
    begin
      Accept:=True;
      ScrollBoxArbre.VertScrollBar.Visible:=False;
      ScrollBoxArbre.HorzScrollBar.Visible:=False;
    end;
end;

procedure TFormParente.Splitter1CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept:=False;
  if (NewSize>30) and ((Height-NewSize-Splitter1.Height)>30) then
    begin
      ScrollBoxArbre.VertScrollBar.Visible:=False;
      ScrollBoxArbre.HorzScrollBar.Visible:=False;
      Accept:=True;
    end;
end;

procedure TFormParente.Verifierarbre;
Var
  i:integer;
  Tax:TTaxon;
begin
  ArbreClade.RazFossiles;
  ArbreClade.RAZExternes;
  For i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
    begin
      Tax:=TTaxon(LaSousCollection.Taxons[i]);
      if LaSousCollection.EstFossile(i) then
        ArbreClade.MarqueCommeFossile(Tax.Nom);
      if LaSousCollection.EstExterne(i) then
        ArbreClade.MarqueCommeExterne(Tax.Nom);
    end;
end;
procedure TFormParente.AjusteActive;
Var
  i:integer;
  LeCarD:TCaractD;
begin
  LaSousCollection.Caracteres.RazDActive;
  for i:=1 to TabGrid1.ColCount-1 do
    begin
      LeCarD:=LaSousCollection.LeCarD(TabGrid1.Cells[i,0]);
      if LeCarD<>Nil then
        begin
          LeCarD.Active:=(TabGrid1.SelectCol[i]=true);
        end;
    end;
end;

procedure TFormParente.RAZClick(Sender: TObject);
begin
  RAZGraphBoites;
  if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
  //Mouchard.Add('RAZ'); //
  Mouchard.Clear;
end;

{procedure TFormParente.Button1Click(Sender: TObject);
begin
  ChCoul.CouleurAncetre:=CouleurAncetreClique;
  ChCoul.CouleurAncCourant:=GCT1.CouleurAncetre;
  ChCoul.CouleurMisEnEvid:=CouleurBranchesGroupe;
  ChCoul.CouleurAncDesc:=CouleurNoeudsGroupe;
  If ChCoul.ShowModal=mrOK then
    begin
      CouleurAncetreClique:=ChCoul.CouleurAncetre;
      ArbreClade.CouleurAncetre:=Color32(ChCoul.CouleurAncCourant);
      CouleurBranchesGroupe:=ChCoul.CouleurMisEnEvid;
      CouleurNoeudsGroupe:=ChCoul.CouleurAncDesc;
      ArbreClade.Redessine;
    end;
end;
}
procedure TFormParente.ArbreCladeMouseDown(Sender: TObject;Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  if Button=mbRight then
    begin
      MenuchoixArbre.Popup(X+PanelArbre.Left,Y+PanelArbre.Top+Top);
    end;
end;
procedure TFormParente.ArbreCladeMouseUp(Sender: TObject;Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  If not InactiveMouseUp then
    begin
      GrapheBoite.RAZSurEncadre;
      ArbreClade.RazCouleurs;
      ArbreClade.Redessine;
      GrapheBoite.Redessine;
      FicheCarAncetre.Close;
      LeDernierAncetreClique:=Nil;
      LaBoiteduDernierAncetreClique:=Nil;
      FicheCarAncetre.GroupeNomme:=Nil;
      ColoreMatrice;
    end;
  InactiveMouseUp:=False;
end;

procedure TFormParente.ActiverClick(Sender: TObject);
begin
  if (Sender as TMenuItem).Tag=0 then
    begin
      ActiverLeDeplacement.Checked:=true;
      FormPrinc.ActiverledplacementTabGrid.Checked:=true;
    end
  else
    begin
      ActiverSelectionCaract.Checked:=True;
      FormPrinc.ActiverlaslectionCaractres.Checked:=True;
    end;

  DeplacementPossible:=ActiverLeDeplacement.Checked;
  if DeplacementPossible then TabGrid1.Options:=TabGrid1.Options+[goColMoving,goRowMoving]
  else TabGrid1.Options:=TabGrid1.Options-[goColMoving,goRowMoving];
end;
procedure TFormParente.RAZGraphBoites;
var
  col:integer;
  ListArray:TStrListArray;
  //ListAges:TStrListArray;
begin
  for col:=1 to TabGrid1.ColCount-1 do
    TabGrid1.SelectCol[col]:=false;
  TabGrid1.invalidate;
  ListArray:=TStrListArray.createlistArray;
  if TableauCorrect then
    FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray)
  else LaSousCollection.TabRef.CopyTo(ListArray);
  //ListAges:=LaSousCollection.CreeTabAges(ListArray);
  GrapheBoite.RaZBoites;
  //FormPrinc.AClasse:=GrapheBoite;
  PosMouchard:=-1;
end;
procedure TFormParente.BDebClick(Sender: TObject);
begin
  RAZGraphBoites;
  if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
end;

procedure TFormParente.BAV1Click(Sender: TObject);
Var
  numcarD,col:integer;
  chaine:string;
  LeCaractD:TCaractD;
begin
  if PosMouchard<(Mouchard.Count-1) then
    begin
      Inc(PosMouchard);
      chaine:=Mouchard[PosMouchard];
      if (chaine[1]<>'-') and (chaine[1]<>'*') then numCarD:=StrToInt(chaine)
      else numCarD:=StrToInt(copy(chaine,2,Length(chaine)-1));
      LeCaractD:=LaSousCollection.CarD[numCarD];
      col:=TabGrid1.Rows[0].IndexOf(LeCaractD.Nom);
      if (col>0) and (col<TabGrid1.ColCount) then
        TabGrid1ClicCaractere(col);
    end;
end;

procedure TFormParente.BAR1Click(Sender: TObject);
Var
  numcarD,col:integer;
  chaine:string;
  LeCaractD:TCaractD;
begin
  if PosMouchard>=0 then
    begin
      chaine:=Mouchard[PosMouchard];
      if (chaine[1]<>'-') and (chaine[1]<>'*') then numCarD:=StrToInt(chaine)
      else numCarD:=StrToInt(copy(chaine,2,Length(chaine)-1));
      LeCaractD:=LaSousCollection.CarD[numCarD];
      col:=TabGrid1.Rows[0].IndexOf(LeCaractD.Nom);
      if (col>0) and (col<TabGrid1.ColCount) then
        TabGrid1ClicCaractere(col);
      Dec(PosMouchard);
    end;
end;

procedure TFormParente.BFinClick(Sender: TObject);
Var
  i,numcarD,col:integer;
  chaine:string;
  LeCaractD:TCaractD;
begin
  if PosMouchard<(Mouchard.Count-1) then
    begin
      For i:=PosMouChard+1 to Mouchard.Count-1 do
        begin
          chaine:=Mouchard[i];
          if (chaine[1]<>'-') and (chaine[1]<>'*') then numCarD:=StrToInt(chaine)
          else numCarD:=StrToInt(copy(chaine,2,Length(chaine)-1));
          LeCaractD:=LaSousCollection.CarD[numCarD];
          col:=TabGrid1.Rows[0].IndexOf(LeCaractD.Nom);
          if (col>0) and (col<TabGrid1.ColCount) then
            TabGrid1ClicCaractere(col);
        end;
      PosMouchard:=Mouchard.Count-1;  
    end;

end;

procedure TFormParente.FormDestroy(Sender: TObject);
begin
  Mouchard.Free;
  MouchardSimplifie.Free;
  EtatsDerives.Free;
  ListeType.Free;
  GroupeANommer.Free;
  ListeTaxonsActifs.Free;
end;

procedure TFormParente.BRej_Click(Sender: TObject);
begin
  FormPrinc.AfficherRejouerClick(BRej);
  if BRej.Down then
    begin
      TextRej.Color:=$00C8FFC8;
      //TabGrid1.Enabled:=False;
      BRAZ.Visible:=False;
      BdeplaClick(BDocs);
      PanRejouer.Visible:=True;
      PanBRaz.Visible:=False;
    end
  else
    begin
      TextRej.Color:=clBtnFace;
      PanRejouer.Visible:=False;
      BRAZ.Visible:=True;
      PanBRaz.Visible:=(PanelBoutons.Height>90);
      BFinClick(Sender);
    end;
  PosMouchard:=Mouchard.Count-1;
end;

procedure TFormParente.BVerifier_ancClick(Sender: TObject);
begin
  Corriger;
end;

procedure TFormParente.BdeplaClick(Sender: TObject);
begin
  if (BRej.Down) and (Sender<>BDocs) then
    begin
      BDocs.Down:=True;
      exit;
    end;
  FormPrinc.ActiverTabGrid1(Sender);
  TextDepla.Color:=clBtnFace;
  TextBoites.Color:=clBtnFace;
  TextDocs.Color:=clBtnFace;
  Bdepla.Down:=False;
  BBoites.Down:=False;
  BDocs.Down:=False;
  Case (Sender as TComponent).Tag of
    0:begin
        TextDepla.Color:=$00C8FFC8;
        Bdepla.Down:=True;        
      end;
    1:begin
        TextBoites.Color:=$00C8FFC8;
        BBoites.Down:=True;
      end;
    2:begin
        TextDocs.Color:=$00C8FFC8;
        BDocs.Down:=True;
      end;
  end;
end;

procedure TFormParente.BMArbre_Click(Sender: TObject);
begin
  FormPrinc.MontrerlarbreClick(BMArbre);
end;

procedure TFormParente.FormHide(Sender: TObject);
begin
  Tabgrid1.CopyToAListArray(0,0,FormPrinc.Adata);
end;

procedure TFormParente.PanelComClick(Sender: TObject);
begin
  ChangeSupport(PanelBoutons.Height>90);
end;

procedure TFormParente.TabGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var
  DebCol,DebLign,i,j,n:integer;
  Colonne:TStringList;
  Tableau:TStringList;
  Selections:Array of Boolean;
begin
  if (Key=82) and (ssCtrl in Shift) then
    begin
      Colonne:=TStringList.Create;
      Tableau:=TStringList.Create;
      for i:=0 to TabGrid1.ColCount-1 do
        begin
          Colonne.Clear;
          Colonne.AddStrings(TabGrid1.Cols[i]);
          TaBleau.Add(Colonne.CommaText);
        end;
      DebCol:=TabGrid1.FixedCols;
      DebLign:=TabGrid1.FixedRows;
      LaSousCollection.ClasseColonnesTableau(DebCol,DebLign,Tableau);
      SetLength(Selections,TabGrid1.ColCount);
      for i:=DebLign to Tableau.Count-1 do
        begin
          Colonne.CommaText:=Tableau[i];
          n:=TabGrid1.Rows[0].IndexOf(Colonne[0]);
          if n>-1 then
            Selections[i]:=TabGrid1.SelectCol[n]
          else Selections[i]:=False;
        end;

      for i:=DebCol to TabGrid1.ColCount-1 do
        begin
          Colonne.CommaText:=Tableau[i];
          TabGrid1.SetSelectCol(i,Selections[i]);
          For j:=0 to Colonne.Count-1 do
            TabGrid1.Cells[i,j]:=Colonne[j];
        end;
      // mise en ordre des Taxons
      Tableau.Clear;
      for i:=0 to TabGrid1.RowCount-1 do
        begin
          Colonne.Clear;
          Colonne.AddStrings(TabGrid1.Rows[i]);
          Tableau.Add(Colonne.CommaText);
        end;
      LaSousCollection.ClasseLignesTableau(DebCol,DebLign,TabGrid1.RowCount-1,Tableau);
      SetLength(Selections,TabGrid1.RowCount);
      for i:=DebLign to Tableau.Count-1 do
        begin
          Colonne.CommaText:=Tableau[i]; //ici Lignes
          n:=TabGrid1.Cols[0].IndexOf(Colonne[0]);
          if n>-1 then
            Selections[i]:=TabGrid1.SelectRow[n]
          else Selections[i]:=False;
        end;

      for i:=DebLign to TabGrid1.RowCount-1 do
        begin
          Colonne.CommaText:=Tableau[i]; //ici Lignes
          TabGrid1.SetSelectRow(i,Selections[i]);
          For j:=0 to Colonne.Count-1 do
            TabGrid1.Cells[j,i]:=Colonne[j];
        end;
      SetLength(Selections,0);
      Tableau.Free;
      Colonne.Free;
      ColoreMatrice;
      TabGrid1.AdjustColWidths;
      TabGrid1.Refresh;
    end;
end;
Procedure TFormParente.Affichetiq(etat:Boolean);
begin
  PanActiv.Visible:=etat;
  PanAfA.Visible:=etat;
  PanBRej.Visible:=etat;
  PanBRaz.Visible:=etat;
end;
Procedure TFormParente.ChangeSupport(Condense:Boolean);
begin
  if Condense then
    begin
      PanelBoutons.Height:=88;
       // 2 lignes  supprimer lorsque la vrification sera fiabilise
      BVerifier.Visible:=False;
      PanelBoutons.Height:=PanelBoutons.Height-BVerifier.Height;
      PanelBoutons.Width:=97;
      BDepla.Parent:=PanelBoutons;
      Bdepla.Top:=0;
      Bdepla.Left:=0;
      Bboites.Parent:=PanelBoutons;
      Bboites.Top:=0;
      Bboites.Left:=32;
      BDocs.Parent:=PanelBoutons;
      BDocs.Top:=0;
      BDocs.Left:=64;
      BMArbre.Parent:=PanelBoutons;
      BMArbre.Top:=31;
      BMArbre.Left:=0;
      BRej.Parent:=PanelBoutons;
      BRej.Top:=31;
      BRej.Left:=32;
      BRaz.Parent:=PanelBoutons;
      BRaz.Top:=31;
      BRaz.Left:=64;
      BVerifier.Top:=62;
      BVerifier.Left:=2;
      BDater.Top:=126;
      BDater.Left:=8;
      Affichetiq(False);
      PanRejouer.Parent:=PanelCom;
      PanRejouer.Top:=PanelBoutons.Top+PanelBoutons.Height+10;
    end
  else
    begin
      PanelBoutons.Height:=224;
      PanelBoutons.Width:=100;
       // 2 lignes  supprimer lorsque la vrification sera fiabilise
      BVerifier.Visible:=False;
      PanelBoutons.Height:=PanelBoutons.Height-BVerifier.Height;
      PanActiv.Parent:=PanelBoutons;
      PanActiv.Top:=0;
      PanActiv.Left:=0;

      BDepla.Parent:=PanBDepl;
      Bdepla.Top:=1;
      Bdepla.Left:=1;
      Bboites.Parent:=PanBBoites;
      Bboites.Top:=1;
      Bboites.Left:=1;
      BDocs.Parent:=PanBDocs;
      BDocs.Top:=1;
      BDocs.Left:=1;

      PanAfA.Parent:=PanelBoutons;
      PanAfA.Top:=103;
      PanAfA.Left:=0;
      BMArbre.Parent:=PanAfA;
      BMArbre.Top:=1;
      BMArbre.Left:=1;
      PanBRej.Parent:=PanelBoutons;
      PanBRej.Top:=134;
      PanBRej.Left:=0;
      BRej.Parent:=PanBRej;
      BRej.Top:=1;
      BRej.Left:=1;
      PanBRaz.Parent:=PanelBoutons;
      PanBRaz.Top:=165;
      PanBRaz.Left:=0;
      BRaz.Parent:=PanBRaz;
      BRaz.Top:=1;
      BRaz.Left:=1;
      BVerifier.Top:=197;
      BVerifier.Left:=2;
      BDater.Top:=260;
      BDater.Left:=8;
      PanRejouer.Parent:=PanelBoutons;
      PanRejouer.Top:=165;
      Affichetiq(True);
    end;
end;

procedure TFormParente.BDaterClick(Sender: TObject);
Var
  i,j,l:integer;
  ChaineStruct:string;
  PasDeFossile:Boolean;
begin
  PasDeFossile:=True;
  For i:=1 to TabGrid1.RowCount-1 do
    begin
      if LaSousCollection.EstFossileNm(TabGrid1.Cells[0,i]) then
        begin
          PasDeFossile:=False;
          break;
        end;
    end;
  if PasDeFossile then
    if MessageDlg('Il n''y a pas de fossile dans le tableau,'
                   +#10#13+'la datation demande une documentation externe.'
                   +#10#13+'Poursuivre ?',mtWarning,[mbNo,mbYes],0)=mrNo then exit;
  FormDater.TabGrid1.ColCount:=TabGrid1.ColCount+2;
  FormDater.TabGrid1.RowCount:=Tabgrid1.RowCount;
  FormDater.TabGrid1.FixedRows:=TabGrid1.FixedRows;
  FormDater.TabGrid1.FixedCols:=3;
  For i:=0 to TabGrid1.RowCount-1 do
    begin
      FormDater.TabGrid1.Cells[0,i]:=TabGrid1.Cells[0,i];
      FormDater.TabGrid1.Cells[1,i]:='';
      FormDater.TabGrid1.Cells[2,i]:='';
    end;
  For i:=0 to TabGrid1.RowCount-1 do
    For j:=1 to TabGrid1.ColCount-1 do
      begin
        FormDater.TabGrid1.Cells[j+2,i]:=TabGrid1.Cells[j,i];
        FormDater.TabGrid1.AffichCell[j+2,i]:=TabGrid1.AffichCell[j,i];
      end;
  ChaineStruct:=GrapheBoite.StructBoite;

  While Pos('<>',ChaineStruct)>0 do
    Delete(ChaineStruct,Pos('<>',ChaineStruct),2);
  FormDater.CreeArbre(ChaineStruct,1);
  FormDater.Top:=0;
  FormDater.Left:=0;
  FormDater.Height:=Screen.WorkAreaHeight;//FormPrinc.Height;
  l:=Splitter2.Left+Splitter2.Width;
  if l<(Width div 2) then l:=(Width div 2);
  FormDater.Width:=l;
  FormDater.InitialiseListeDocs;
  FormDater.ShowModal;
  //Hide;
end;

procedure TFormParente.ScrollBoxArbreResize(Sender: TObject);
begin
{  if ArbreClade<>Nil then
    if Length(ArbreClade.Branches)>3 then
      begin
        ArbreClade.LargeurDisponible:=ScrollBoxArbre.ClientWidth-1;//
        ArbreClade.HauteurDisponible:=ScrollBoxArbre.ClientHeight-1;
        ArbreClade.Redessine;
      end;
      }
end;
{
procedure TFormParente.AfficherBoitesArbreClick(Sender: TObject);
begin
  if AfficherBoitesArbre.Checked then
    begin
      ArbreClade.DessinerBoites:=False;
      ArbreClade.Redessine;
      AfficherBoitesArbre.Checked:=False;
    end
  else
    begin
      ArbreClade.DessinerBoites:=True;
      ArbreClade.Redessine;
      AfficherBoitesArbre.Checked:=True;
    end;
end;
}
{procedure TFormParente.AfficherGroupesClick(Sender: TObject);
begin
  if BoitesGroupe.Checked then
    begin
      ArbreClade.BoitesSansTaxons:=False;
      ArbreClade.Redessine;
      BoitesGroupe.Checked:=False;
    end
  else
    begin
      ArbreClade.BoitesSansTaxons:=True;
      ArbreClade.Redessine;
      BoitesGroupe.Checked:=True;
    end;
end;
procedure TFormParente.CalculeCouleursBoites;
Var
  n,fc,i,j,p,maxetats:integer;
  UnCarD:TCaractD;
begin
  n:=0;
  SetLength(CouleursBoites,TabGrid1.ColCount-TabGrid1.FixedCols);
  fc:=TabGrid1.FixedCols;
  For i:=fc to TabGrid1.ColCount-1 do
    begin
      UnCarD:=LaSousCollection.LeCarD(TabGrid1.Cells[i,0]);
      if UnCarD<>Nil then
        begin
          p:=UnCarD.ListeEtats.Count-1;
          if UnCarD.ListeEtats[p]='?' then
            p:=p-1;
          if p>=0 then SetLength(CouleursBoites[i-fc],p);
          for j:=0 to p-1 do
            begin
              CouleursBoites[i-fc,j]:=Color32(CouleursCaractDBoites[n mod Length(CouleursCaractDBoites)]);
              inc(n)
            end;
        end;
    end;
end;
}

procedure TFormParente.BChoixClick(Sender: TObject);
begin
  MenuChoixArbre.Popup(Splitter2.Left+BChoix.Width,PanelActivArbre.Top+80);
end;

procedure TFormParente.ArbreModifiableClick(Sender: TObject);
begin
  ArbreModifiable.Checked:=Not ArbreModifiable.Checked;
  ArbreClade.EstModifiable:=ArbreModifiable.Checked;
end;

procedure TFormParente.AfficherTaxonsClick(Sender: TObject);
begin
  if (Not AfficherBoitesArbre.Checked) or (Not AfficherGroupes.Checked) then
    begin
      AfficherTaxons.Checked:=True;
      AfficherGroupes.Checked:=False;
    end
  else
    begin
      if Not AfficherTaxons.Checked then
        begin
          AfficherTaxons.Checked:=True;
          ArbreClade.BoitesSansTaxons:=False;
          ArbreClade.Redessine;
        end
      else
        begin
          AfficherTaxons.Checked:=False;
          ArbreClade.BoitesSansTaxons:=True;
          ArbreClade.Redessine;
        end;
    end;
end;

procedure TFormParente.AfficherBoitesArbreClick(Sender: TObject);
begin
  if AfficherBoitesArbre.Checked then
    begin
      ArbreClade.DessinerBoites:=False;
      AfficherBoitesArbre.Checked:=False;
      ArbreClade.BoitesSansTaxons:=False;
      AfficherGroupes.Checked:=False;
      AfficherGroupes.Enabled:=False;
      AfficherTaxons.Checked:=True;
      AfficherTaxons.Enabled:=False;
      ArbreClade.Redessine;
    end
  else
    begin
      If AfficherGroupes.Checked then
        AfficherTaxons.Enabled:=True;
      AfficherGroupes.Enabled:=True;
      ArbreClade.DessinerBoites:=True;
      ArbreClade.ColoreBoitesParDefaut;
      ArbreClade.Redessine;
      AfficherBoitesArbre.Checked:=True;
    end;
end;

procedure TFormParente.AfficherGroupesClick(Sender: TObject);
begin
  if AfficherGroupes.Checked then
    begin
      ArbreClade.BoitesSansTaxons:=False;
      Arbreclade.AfficherNomsGroupes:=False;
      ArbreClade.Redessine;
      AfficherGroupes.Checked:=False;
      AfficherTaxons.Checked:=True;
      AfficherTaxons.Enabled:=False;
    end
  else
    begin
      Arbreclade.AfficherNomsGroupes:=True;
      if AfficherBoitesArbre.Checked then
        AfficherTaxons.Enabled:=True;
      if Not AfficherTaxons.Checked then
        ArbreClade.BoitesSansTaxons:=True;
      ArbreClade.Redessine;
      AfficherGroupes.Checked:=True;
    end;
end;

procedure TFormParente.FormShow(Sender: TObject);
begin
  ScrollBoxArbreResize(Self);
end;

procedure TFormParente.PanelArbreResize(Sender: TObject);
begin
  if ArbreClade<>Nil then
    if Length(ArbreClade.Branches)>1 then
      begin
        //ScrollBoxArbre.VertScrollBar.Visible:=False;
        //ScrollBoxArbre.HorzScrollBar.Visible:=False;
        //ScrollBoxArbre.Width:=PanelArbre.ClientWidth;
        //ScrollBoxArbre.Height:=PanelArbre.ClientHeight-PanelActivArbre.Height;
        ArbreClade.LargeurDisponible:=PanelArbre.ClientWidth-12;//
        ArbreClade.HauteurDisponible:=PanelArbre.ClientHeight-PanelActivArbre.Height-12;//
        ArbreClade.Redessine;
        ScrollBoxArbre.VertScrollBar.Visible:=True;
        ScrollBoxArbre.HorzScrollBar.Visible:=True;
      end;
end;

end.
