unit chxCoul;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TChCoul = class(TForm)
    BCoulAnCC: TButton;
    ColorDialog: TColorDialog;
    BCoulClic: TButton;
    BCoulAncGr: TButton;
    Button1: TButton;
    CoulAncCour: TPanel;
    CoulAncClic: TPanel;
    CoulancDesc: TPanel;
    CoulMisEv: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure BCoulAnCCClick(Sender: TObject);
    procedure BCoulClicClick(Sender: TObject);
    procedure BCoulAncGrClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  CouleurAncetre:TColor;
  CouleurMisEnEvid:TColor;
  CouleurAncDesc:Tcolor;
  CouleurAncCourant:Tcolor;

  end;

var
  ChCoul: TChCoul;

implementation

{$R *.dfm}

procedure TChCoul.FormShow(Sender: TObject);
begin
  CoulAncClic.Color:=CouleurAncetre;
  CoulMisEv.Color:=CouleurMisEnEvid;
  CoulancDesc.Color:=CouleurAncDesc;
  CoulAncCour.Color:=CouleurAncCourant;
end;

procedure TChCoul.BCoulAnCCClick(Sender: TObject);
begin
  ColorDialog.Color:=CouleurAncCourant;
  if ColorDialog.Execute then
    begin
      CouleurAncCourant:=ColorDialog.Color;
      CoulAncCour.Color:=CouleurAncCourant;
    end;
end;

procedure TChCoul.BCoulClicClick(Sender: TObject);
begin
  ColorDialog.Color:=CouleurAncetre;
  if ColorDialog.Execute then
    begin
      CouleurAncetre:=ColorDialog.Color;
      CoulAncClic.Color:=CouleurAncetre;
    end;
end;

procedure TChCoul.BCoulAncGrClick(Sender: TObject);
begin
  ColorDialog.Color:=CouleurAncDesc;
  if ColorDialog.Execute then
    begin
      CouleurAncDesc:=ColorDialog.Color;
      CoulancDesc.Color:=CouleurAncDesc;
    end;
end;

procedure TChCoul.Button1Click(Sender: TObject);
begin
  ColorDialog.Color:=CouleurMisEnEvid;
  if ColorDialog.Execute then
    begin
      CouleurMisEnEvid:=ColorDialog.Color;
      CoulMisEv.Color:=CouleurMisEnEvid;
    end;
end;

end.
